#pragma once

#include <vector>
#include <cstdint>

class BitStream
{
public:
  BitStream() 
    : m_tmp(0), m_usedBits(0)
  {
  };

  // Put upper n bits of data into buffer
  void putBits(uint8_t data, uint8_t n)
  {
    data &= ~((1 << (8-n)) - 1);
    m_tmp |= data >> m_usedBits;
    m_usedBits += n;
    if(m_usedBits >= 8)
    {
      m_buffer.push_back(m_tmp);
      m_usedBits -= 8;
      m_tmp = data << (n - m_usedBits);
    }
  }

  std::vector<uint8_t> getData() const
  {
    std::vector<uint8_t> out = m_buffer;
    if(m_usedBits)
      out.push_back(m_tmp);
    return out;
  }

private:
  std::vector<uint8_t> m_buffer;
  uint8_t m_tmp, m_usedBits;
};
