#pragma once

#include <vector>
#include <cstdint>

#include <ft2build.h>
#include FT_FREETYPE_H

struct FontMetrics
{
  int ascender;   // height above baseline
  int descender;  // font below baseline (height = ascender + descender)
  int width;
};

struct Glyph
{
  int width, height;
  int xPos, yPos;
  int advance;
  std::vector<uint8_t> buffer;

  Glyph()
    : width(0), height(0),
      xPos(0), yPos(0),
      advance(0)
  {
  }
};

class FontRenderer
{
public:
  FontRenderer();
  ~FontRenderer();

  void LoadFont(const std::string& filename, int size);
  Glyph RenderGlyph(int character);

  FontMetrics GetMetrics() const { return m_metrics; }

private:
  FT_Library m_ft;
  FT_Face m_face;
  FontMetrics m_metrics;
};